OAuth2::AccessToken -

# abstract class OAuth2::AccessToken

- OAuth2::AccessToken
- Reference
- Object

## Overview

Base class for the two possible access tokens: Bearer and Mac.

Use `#authenticate` to authenticate an `HTTP::Client`.

## Direct Known Subclasses

- OAuth2::AccessToken::Bearer
- OAuth2::AccessToken::Mac

## Defined in:

## Constructors

- .new(access_token : String, expires_in : Int?, refresh_token : String? = nil, scope : String? = nil, extra = nil)
- .new(pull : JSON::PullParser)

## Instance Method Summary

- #access_token : String
- #access_token=(access_token : String)
- #authenticate(request : HTTP::Request, tls)
- #authenticate(client : HTTP::Client)
- #expires_in : Int64?
- #expires_in=(expires_in : Int64?)
- #extra : Hash(String, String)?

  JSON key-value pairs that are outside of the OAuth2 spec are stored in this property in case they are needed.

- #extra=(extra : Hash(String, String)?)

  JSON key-value pairs that are outside of the OAuth2 spec are stored in this property in case they are needed.

- #refresh_token : String?
- #refresh_token=(refresh_token : String?)
- #scope : String?
- #scope=(scope : String?)

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new(access_token : String, expires_in : Int?, refresh_token : String? = nil, scope : String? = nil, extra = nil) #
def self.new(pull : JSON::PullParser) #

## Instance Method Detail

def access_token : String #
def access_token=(access_token : String) #
abstract def authenticate(request : HTTP::Request, tls) #
def authenticate(client : HTTP::Client) #
def expires_in : Int64? #
def expires_in=(expires_in : Int64?) #
def extra : Hash(String, String)? #

JSON key-value pairs that are outside of the OAuth2 spec are stored in this property in case they are needed. Their value is the raw JSON string found in the JSON value (with possible changes in the string format, but preserving JSON semantic). For example if the value was `[1, 2, 3]` then the value in this hash will be the string "[1,2,3]".

def extra=(extra : Hash(String, String)?) #

JSON key-value pairs that are outside of the OAuth2 spec are stored in this property in case they are needed. Their value is the raw JSON string found in the JSON value (with possible changes in the string format, but preserving JSON semantic). For example if the value was `[1, 2, 3]` then the value in this hash will be the string "[1,2,3]".

def refresh_token : String? #
def refresh_token=(refresh_token : String?) #
def scope : String? #
def scope=(scope : String?) #